# Single-Layer Distillation with Fourier Convolutions for Texture Anomaly Detection

## Download links :

MVTEC AD : https://www.mvtec.com/company/research/datasets/mvtec-ad  
TILDA : https://lmb.informatik.uni-freiburg.de/resources/datasets/tilda.en.html  
dagm : https://conferences.mpi-inf.mpg.de/dagm/2007/prizes.html  
aitex : https://www.aitex.es/afid/

TILDA, Aitex and DAGM datasets need to be converted to the MVTEC AD format before processing.

## Dependencies :

To install the dependencies :

```
pip3 install -r requirements.txt
```

## Test the model on MVTEC AD textures

To test the pretrained weights on MVTEC AD, please download the dataset.
After download or if you already have the MVTEC dataset in your computer, please change the data_path parameter in config.yaml.

```
python3 testBest.py --mvtec
```

To test on other datasets, please replace --mvtec with either --tilda --aitex or --dagm

## Training the model

To train the model, change the obj parameter in the file config.yaml to specify the class you want to train and change the data_path to your data.
Then run

```
python3 train.py
```
